/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse ISASM_parse
#define yylex   ISASM_lex
#define yyerror ISASM_error
#define yylval  ISASM_lval
#define yychar  ISASM_char
#define yydebug ISASM_debug
#define yynerrs ISASM_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     VAR = 258,
     FUNC = 259,
     PARAM = 260,
     RETVAL = 261,
     IDENT = 262,
     INTEGER = 263,
     FLOAT = 264,
     STRING = 265,
     MOV = 266,
     ADD = 267,
     SUB = 268,
     MUL = 269,
     DIV = 270,
     MOD = 271,
     NEG = 272,
     INC = 273,
     DEC = 274,
     LOGICAND = 275,
     LOGICOR = 276,
     BITAND = 277,
     BITOR = 278,
     XOR = 279,
     NOT = 280,
     SHL = 281,
     SHR = 282,
     CONCAT = 283,
     GETCHAR = 284,
     SETCHAR = 285,
     CMPE = 286,
     CMPNE = 287,
     CMPG = 288,
     CMPGE = 289,
     CMPL = 290,
     CMPLE = 291,
     JMP = 292,
     JZ = 293,
     JNZ = 294,
     PUSH = 295,
     POP = 296,
     CALL = 297,
     CALLHOST = 298,
     CALLOBJ = 299,
     RET = 300,
     THIS = 301
   };
#endif
#define VAR 258
#define FUNC 259
#define PARAM 260
#define RETVAL 261
#define IDENT 262
#define INTEGER 263
#define FLOAT 264
#define STRING 265
#define MOV 266
#define ADD 267
#define SUB 268
#define MUL 269
#define DIV 270
#define MOD 271
#define NEG 272
#define INC 273
#define DEC 274
#define LOGICAND 275
#define LOGICOR 276
#define BITAND 277
#define BITOR 278
#define XOR 279
#define NOT 280
#define SHL 281
#define SHR 282
#define CONCAT 283
#define GETCHAR 284
#define SETCHAR 285
#define CMPE 286
#define CMPNE 287
#define CMPG 288
#define CMPGE 289
#define CMPL 290
#define CMPLE 291
#define JMP 292
#define JZ 293
#define JNZ 294
#define PUSH 295
#define POP 296
#define CALL 297
#define CALLHOST 298
#define CALLOBJ 299
#define RET 300
#define THIS 301




/* Copy the first part of user declarations.  */
#line 2 "parser.y"


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <isis/ivm/isasm.h>

#define quit ISASM_quit



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 15 "parser.y"
typedef union YYSTYPE {
    int int_val;
    float float_val;
    int name_index;
    RVAL rval;
    LVAL lval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 197 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 209 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   268

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  58
/* YYNRULES -- Number of rules. */
#define YYNRULES  111
/* YYNRULES -- Number of states. */
#define YYNSTATES  313

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      53,    54,     2,     2,    55,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    52,    47,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    48,     2,    49,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    50,     2,    51,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     6,     7,    10,    12,    14,    18,    25,
      28,    30,    38,    40,    43,    44,    47,    51,    52,    55,
      57,    59,    63,    70,    71,    74,    77,    80,    83,    87,
      89,    91,    93,    95,    97,    99,   101,   103,   105,   107,
     109,   111,   113,   115,   117,   119,   121,   123,   125,   127,
     129,   131,   133,   135,   137,   139,   141,   143,   145,   147,
     149,   151,   153,   155,   157,   159,   165,   173,   181,   189,
     197,   205,   211,   217,   223,   231,   239,   247,   255,   263,
     269,   277,   285,   293,   301,   309,   317,   325,   333,   341,
     349,   357,   361,   367,   373,   377,   381,   387,   393,   401,
     404,   407,   409,   414,   419,   421,   423,   428,   433,   435,
     437,   439
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      57,     0,    -1,    58,    62,    -1,    -1,    58,    59,    -1,
      60,    -1,    61,    -1,     3,     7,    47,    -1,     3,     7,
      48,     8,    49,    47,    -1,    62,    63,    -1,    63,    -1,
       4,    64,    50,    65,    72,   111,    51,    -1,     7,    -1,
      66,    68,    -1,    -1,    66,    67,    -1,     5,     7,    47,
      -1,    -1,    68,    69,    -1,    70,    -1,    71,    -1,     3,
       7,    47,    -1,     3,     7,    48,     8,    49,    47,    -1,
      -1,    72,    73,    -1,    72,    74,    -1,    72,    75,    -1,
       7,    52,    -1,    53,     8,    54,    -1,    76,    -1,    77,
      -1,    78,    -1,    79,    -1,    80,    -1,    81,    -1,    82,
      -1,    83,    -1,    84,    -1,    85,    -1,    86,    -1,    87,
      -1,    88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,
      -1,    93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,
      -1,   103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,
      -1,   108,    -1,   109,    -1,   110,    -1,   111,    -1,    11,
     112,    55,   113,    47,    -1,    12,   112,    55,   113,    55,
     113,    47,    -1,    13,   112,    55,   113,    55,   113,    47,
      -1,    14,   112,    55,   113,    55,   113,    47,    -1,    15,
     112,    55,   113,    55,   113,    47,    -1,    16,   112,    55,
     113,    55,   113,    47,    -1,    17,   112,    55,   113,    47,
      -1,    18,   112,    55,   113,    47,    -1,    19,   112,    55,
     113,    47,    -1,    20,   112,    55,   113,    55,   113,    47,
      -1,    21,   112,    55,   113,    55,   113,    47,    -1,    22,
     112,    55,   113,    55,   113,    47,    -1,    23,   112,    55,
     113,    55,   113,    47,    -1,    24,   112,    55,   113,    55,
     113,    47,    -1,    25,   112,    55,   113,    47,    -1,    26,
     112,    55,   113,    55,   113,    47,    -1,    27,   112,    55,
     113,    55,   113,    47,    -1,    28,   112,    55,   113,    55,
     113,    47,    -1,    29,   112,    55,   113,    55,   113,    47,
      -1,    30,   112,    55,   113,    55,   113,    47,    -1,    31,
     112,    55,   113,    55,   113,    47,    -1,    32,   112,    55,
     113,    55,   113,    47,    -1,    33,   112,    55,   113,    55,
     113,    47,    -1,    34,   112,    55,   113,    55,   113,    47,
      -1,    35,   112,    55,   113,    55,   113,    47,    -1,    36,
     112,    55,   113,    55,   113,    47,    -1,    37,     7,    47,
      -1,    38,   113,    55,     7,    47,    -1,    39,   113,    55,
       7,    47,    -1,    40,   113,    47,    -1,    41,   112,    47,
      -1,    42,     7,    55,   113,    47,    -1,    43,     7,    55,
     113,    47,    -1,    44,   112,    55,     7,    55,   113,    47,
      -1,    46,    47,    -1,    45,    47,    -1,     7,    -1,     7,
      48,     8,    49,    -1,     7,    48,     7,    49,    -1,     6,
      -1,     7,    -1,     7,    48,     8,    49,    -1,     7,    48,
       7,    49,    -1,     6,    -1,     8,    -1,     9,    -1,    10,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    44,    44,    49,    50,    53,    54,    57,    60,    65,
      66,    69,    73,    76,    79,    80,    83,    86,    87,    90,
      91,    94,    97,   100,   101,   102,   103,   106,   109,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   151,   155,   159,   163,   167,
     171,   175,   178,   181,   185,   189,   193,   197,   201,   205,
     208,   212,   217,   221,   225,   230,   234,   238,   242,   246,
     250,   255,   258,   261,   265,   268,   272,   275,   278,   282,
     285,   288,   292,   296,   303,   306,   311,   318,   327,   329,
     331,   333
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "VAR", "FUNC", "PARAM", "RETVAL",
  "IDENT", "INTEGER", "FLOAT", "STRING", "MOV", "ADD", "SUB", "MUL", "DIV",
  "MOD", "NEG", "INC", "DEC", "LOGICAND", "LOGICOR", "BITAND", "BITOR",
  "XOR", "NOT", "SHL", "SHR", "CONCAT", "GETCHAR", "SETCHAR", "CMPE",
  "CMPNE", "CMPG", "CMPGE", "CMPL", "CMPLE", "JMP", "JZ", "JNZ", "PUSH",
  "POP", "CALL", "CALLHOST", "CALLOBJ", "RET", "THIS", "';'", "'['", "']'",
  "'{'", "'}'", "':'", "'('", "')'", "','", "$accept", "asmfile",
  "globallist", "globaldec", "globalscalar", "globalarray", "functionlist",
  "function", "funcname", "funcheader", "paramlist", "param", "locallist",
  "localdec", "localscalar", "localarray", "instrlist", "label", "lineno",
  "instr", "mov", "add", "sub", "mul", "div", "mod", "neg", "inc", "dec",
  "logicand", "logicor", "bitand", "bitor", "xor", "not", "shl", "shr",
  "concat", "getchar", "setchar", "cmpe", "cmpne", "cmpg", "cmpge", "cmpl",
  "cmple", "jmp", "jz", "jnz", "push", "pop", "call", "callhost",
  "callobj", "this", "ret", "lvalue", "rvalue", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    59,    91,    93,
     123,   125,    58,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    56,    57,    58,    58,    59,    59,    60,    61,    62,
      62,    63,    64,    65,    66,    66,    67,    68,    68,    69,
      69,    70,    71,    72,    72,    72,    72,    73,    74,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   112,   112,   112,   113,   113,   113,   113,   113,
     113,   113
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     0,     2,     1,     1,     3,     6,     2,
       1,     7,     1,     2,     0,     2,     3,     0,     2,     1,
       1,     3,     6,     0,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     7,     7,     7,     7,
       7,     5,     5,     5,     7,     7,     7,     7,     7,     5,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     3,     5,     5,     3,     3,     5,     5,     7,     2,
       2,     1,     4,     4,     1,     1,     4,     4,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     0,     1,     0,     0,     4,     5,     6,     2,
      10,     0,    12,     0,     9,     7,     0,    14,     0,    23,
      17,     0,     0,     0,    15,    13,     8,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,    25,    26,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,    18,    19,    20,    27,
     104,   101,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   108,
     105,   109,   110,   111,     0,     0,     0,     0,     0,     0,
       0,   100,    99,     0,    11,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,     0,     0,     0,    94,    95,
       0,     0,     0,    28,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   103,   102,    65,     0,     0,     0,     0,     0,
      71,    72,    73,     0,     0,     0,     0,     0,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     107,   106,    92,    93,    96,    97,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    66,    67,    68,    69,    70,    74,    75,    76,    77,
      78,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    98
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,     6,     7,     8,     9,    10,    13,    19,
      20,    24,    25,   106,   107,   108,    22,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   112,   144
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -57
static const short int yypact[] =
{
     -57,     5,     0,   -57,    40,    79,   -57,   -57,   -57,    83,
     -57,    27,   -57,    38,   -57,   -57,    81,   -57,    41,   -57,
      86,    45,    -5,    87,   -57,    90,   -57,    43,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    89,    36,    36,    36,    70,    91,
      92,    70,    50,    53,    93,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,    78,    84,   121,   -57,   -57,   -57,   -57,
     -57,    82,    85,    88,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   126,   -57,
     127,   -57,   -57,   -57,   119,   122,   129,   131,   130,   137,
     149,   -57,   -57,   132,   -57,   -57,    32,    75,    36,    36,
      36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
      36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
      36,    36,    36,    36,   -57,    77,   125,   134,   -57,   -57,
      36,    36,   135,   -57,   -57,   128,   156,   157,   160,   153,
     154,   158,   159,   161,   164,   165,   168,   162,   163,   166,
     167,   169,   172,   170,   171,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   188,   189,   192,   193,   194,   195,
     190,   197,   -57,   -57,   -57,    36,    36,    36,    36,    36,
     -57,   -57,   -57,    36,    36,    36,    36,    36,   -57,    36,
      36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
     -57,   -57,   -57,   -57,   -57,   -57,    36,   196,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   124,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,    20,   -56
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short int yytable[] =
{
     145,   146,    27,     4,     5,     3,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,   139,   140,   141,   142,   143,    11,    64,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    15,    16,   110,   111,   147,   194,
     195,   150,   196,   197,   224,   225,    12,     5,    17,    18,
      21,    23,    26,   105,   104,   109,   138,   151,   148,   149,
     152,   153,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   156,   154,
     157,   155,   226,    14,   228,   229,   231,     0,     0,     0,
     158,   227,   230,   159,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   186,   185,   188,   187,   189,   268,
     269,   270,   271,   272,     0,   190,   193,   273,   274,   275,
     276,   277,   191,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   192,   232,   233,   234,   235,   236,
     289,   240,   241,   237,   238,   242,   239,   243,   244,   248,
       0,   245,   246,     0,   247,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   290,     0,   266,   267,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312
};

static const short int yycheck[] =
{
      56,    57,     7,     3,     4,     0,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,     6,     7,     8,     9,    10,     7,    53,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    47,    48,     6,     7,    58,    47,
      48,    61,     7,     8,     7,     8,     7,     4,    50,     8,
      49,     5,    47,     3,     7,    52,     7,    47,     7,     7,
      47,     8,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,     7,    51,
      48,    47,     7,     9,   190,   191,     8,    -1,    -1,    -1,
      55,     7,     7,    55,    -1,    -1,    -1,    -1,    -1,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    47,    55,    48,    47,    55,    47,   235,
     236,   237,   238,   239,    -1,    55,    54,   243,   244,   245,
     246,   247,    55,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    55,    49,    49,    47,    55,    55,
     266,    47,    47,    55,    55,    47,    55,    55,    55,    47,
      -1,    55,    55,    -1,    55,    55,    55,    -1,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    49,    49,    47,
      47,    47,    47,    47,    -1,    55,    49,    47,    47,    47,
      47,    47,    47,    47,    47,    47,    47,    47,    47,    47,
      47,    47,    47,    47,    47,    47,    47,    47,    47
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    57,    58,     0,     3,     4,    59,    60,    61,    62,
      63,     7,     7,    64,    63,    47,    48,    50,     8,    65,
      66,    49,    72,     5,    67,    68,    47,     7,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    53,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,     7,     3,    69,    70,    71,    52,
       6,     7,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,     7,     6,
       7,     8,     9,    10,   113,   113,   113,   112,     7,     7,
     112,    47,    47,     8,    51,    47,     7,    48,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    47,    48,    55,    55,    47,    47,
      55,    55,    55,    54,    47,    48,     7,     8,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,     7,     8,     7,     7,   113,   113,
       7,     8,    49,    49,    47,    55,    55,    55,    55,    55,
      47,    47,    47,    55,    55,    55,    55,    55,    47,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      49,    49,    47,    47,    47,    47,    55,    49,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
      47,    47,    47,    47,    47,    47,    47,    47,    47,    47,
      47,    47,    47,    47,    47,    47,    47,    47,    47,    47,
      47,    47,    47
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 44 "parser.y"
    { resolve_call_targets(); 
                                    resolve_callhost_targets();
                                    resolve_callobj_targets(); }
    break;

  case 7:
#line 57 "parser.y"
    { symbol_table_add(yyvsp[-1].name_index,SYM_GLOBAL_SCALAR); }
    break;

  case 8:
#line 60 "parser.y"
    { int sym_index = 
                                      symbol_table_add(yyvsp[-4].name_index, SYM_GLOBAL_ARRAY);
                                      set_symbol_extra_info(sym_index,yyvsp[-2].int_val); }
    break;

  case 11:
#line 69 "parser.y"
    {
             instr_num++; resolve_label_jumps(); isasm_clear_func_symbols(); }
    break;

  case 12:
#line 73 "parser.y"
    { isasm_func_num = isasm_new_func(yyvsp[0].name_index); }
    break;

  case 13:
#line 76 "parser.y"
    { isasm_calc_func_locals_size(); }
    break;

  case 16:
#line 83 "parser.y"
    { isasm_add_param(yyvsp[-1].name_index); }
    break;

  case 21:
#line 94 "parser.y"
    { isasm_add_local_scalar(yyvsp[-1].name_index); }
    break;

  case 22:
#line 97 "parser.y"
    { add_local_array(yyvsp[-4].name_index,yyvsp[-2].int_val); }
    break;

  case 26:
#line 103 "parser.y"
    { instr_num++; }
    break;

  case 27:
#line 106 "parser.y"
    { label_table_set(label_table_add(yyvsp[-1].name_index),instr_num); }
    break;

  case 28:
#line 109 "parser.y"
    { lineno_table_add(yyvsp[-1].int_val,instr_num); }
    break;

  case 65:
#line 151 "parser.y"
    { emit_instr_lvalrval(INSTR_MOV,&yyvsp[-3].lval,&yyvsp[-1].rval); }
    break;

  case 66:
#line 156 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_ADD,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 67:
#line 160 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_SUB,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 68:
#line 164 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_MUL,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 69:
#line 168 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_DIV,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 70:
#line 172 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_MOD,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 71:
#line 175 "parser.y"
    { emit_instr_lvalrval(INSTR_NEG,&yyvsp[-3].lval,&yyvsp[-1].rval); }
    break;

  case 72:
#line 178 "parser.y"
    { emit_instr_lvalrval(INSTR_INC,&yyvsp[-3].lval,&yyvsp[-1].rval); }
    break;

  case 73:
#line 181 "parser.y"
    { emit_instr_lvalrval(INSTR_DEC,&yyvsp[-3].lval,&yyvsp[-1].rval); }
    break;

  case 74:
#line 186 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_LOGICAND,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 75:
#line 190 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_LOGICOR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 76:
#line 194 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_BITAND,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 77:
#line 198 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_BITOR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 78:
#line 202 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_XOR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 79:
#line 205 "parser.y"
    { emit_instr_lvalrval(INSTR_NOT,&yyvsp[-3].lval,&yyvsp[-1].rval); }
    break;

  case 80:
#line 209 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_SHL,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 81:
#line 213 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_SHR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 82:
#line 218 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CONCAT,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 83:
#line 221 "parser.y"
    { 
                          emit_instr_lvalrvalrval(INSTR_GETCHAR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 84:
#line 225 "parser.y"
    { 
                          emit_instr_lvalrvalrval(INSTR_SETCHAR,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 85:
#line 231 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPE,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 86:
#line 235 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPNE,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 87:
#line 239 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPG,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 88:
#line 243 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPGE,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 89:
#line 247 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPL,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 90:
#line 251 "parser.y"
    { emit_instr_lvalrvalrval(INSTR_CMPLE,&yyvsp[-5].lval,&yyvsp[-3].rval,&yyvsp[-1].rval); }
    break;

  case 91:
#line 255 "parser.y"
    { emit_instr_jmp(yyvsp[-1].name_index); }
    break;

  case 92:
#line 258 "parser.y"
    { emit_instr_jz(yyvsp[-1].name_index,&yyvsp[-3].rval); }
    break;

  case 93:
#line 261 "parser.y"
    { emit_instr_jnz(yyvsp[-1].name_index,&yyvsp[-3].rval); }
    break;

  case 94:
#line 265 "parser.y"
    { emit_instr_rval(INSTR_PUSH,&yyvsp[-1].rval); }
    break;

  case 95:
#line 268 "parser.y"
    { emit_instr_lval(INSTR_POP,&yyvsp[-1].lval); }
    break;

  case 96:
#line 272 "parser.y"
    {  emit_instr_call(yyvsp[-3].name_index,&yyvsp[-1].rval); }
    break;

  case 97:
#line 275 "parser.y"
    { emit_instr_callhost(yyvsp[-3].name_index,&yyvsp[-1].rval); }
    break;

  case 98:
#line 278 "parser.y"
    { 
                                              emit_instr_callobj(&yyvsp[-5].lval,yyvsp[-3].name_index,&yyvsp[-1].rval); }
    break;

  case 99:
#line 282 "parser.y"
    { emit_instr_this(); }
    break;

  case 100:
#line 285 "parser.y"
    { emit_instr_ret(); }
    break;

  case 101:
#line 288 "parser.y"
    { yyval.lval.symbol_index = find_closest_symbol(yyvsp[0].name_index);
                  if (-1 == yyval.lval.symbol_index) 
                      quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[0].name_index));
                  yyval.lval.type = LVAL_SCALAR; yyval.lval.offset.literal = 0; }
    break;

  case 102:
#line 292 "parser.y"
    { yyval.lval.symbol_index = find_closest_symbol(yyvsp[-3].name_index);
                                if (-1 == yyval.lval.symbol_index) 
                         quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-3].name_index));
                            yyval.lval.type = LVAL_ARRAY_LIT; yyval.lval.offset.literal = yyvsp[-1].int_val; }
    break;

  case 103:
#line 296 "parser.y"
    { yyval.lval.symbol_index = find_closest_symbol(yyvsp[-3].name_index);
                              if (-1 == yyval.lval.symbol_index) 
                         quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-3].name_index));
                              yyval.lval.type = LVAL_ARRAY_SYM; 
                              yyval.lval.offset.symbol_index = find_closest_symbol(yyvsp[-1].name_index);
                            if (-1 == yyval.lval.offset.symbol_index) 
                       quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-1].name_index)); }
    break;

  case 104:
#line 303 "parser.y"
    { yyval.lval.type = LVAL_RETVAL; }
    break;

  case 105:
#line 306 "parser.y"
    { yyval.rval.val.lval.symbol_index = find_closest_symbol(yyvsp[0].name_index);
                  if (-1 == yyval.rval.val.lval.symbol_index) 
                      quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[0].name_index));
                  yyval.rval.type = RVAL_LVAL; yyval.rval.val.lval.type = LVAL_SCALAR; 
                  yyval.rval.val.lval.offset.literal= 0; }
    break;

  case 106:
#line 311 "parser.y"
    { yyval.rval.val.lval.symbol_index = 
                                               find_closest_symbol(yyvsp[-3].name_index);
                              if (-1 == yyval.rval.val.lval.symbol_index) 
                         quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-3].name_index));
                              yyval.rval.type = RVAL_LVAL; 
                              yyval.rval.val.lval.type = LVAL_ARRAY_LIT; 
                              yyval.rval.val.lval.offset.literal= yyvsp[-1].int_val; }
    break;

  case 107:
#line 318 "parser.y"
    { yyval.rval.val.lval.symbol_index = 
                                    find_closest_symbol(yyvsp[-3].name_index);
                              if (-1 == yyval.rval.val.lval.symbol_index) 
                         quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-3].name_index));
                              yyval.rval.type = RVAL_LVAL;
                              yyval.rval.val.lval.type = LVAL_ARRAY_SYM; 
                     yyval.rval.val.lval.offset.symbol_index = find_closest_symbol(yyvsp[-1].name_index);
                            if (-1 == yyval.rval.val.lval.offset.symbol_index) 
                       quit("Unknown symbol: %s\n",isasm_name_table_get(yyvsp[-1].name_index)); }
    break;

  case 108:
#line 327 "parser.y"
    { yyval.rval.type = RVAL_LVAL; 
                                  yyval.rval.val.lval.type = LVAL_RETVAL; }
    break;

  case 109:
#line 329 "parser.y"
    { yyval.rval.type = RVAL_INTEGER;
                                  yyval.rval.val.int_val = yyvsp[0].int_val; }
    break;

  case 110:
#line 331 "parser.y"
    { yyval.rval.type = RVAL_FLOAT;
                                  yyval.rval.val.float_val = yyvsp[0].float_val; }
    break;

  case 111:
#line 333 "parser.y"
    { yyval.rval.type = RVAL_STRINGIND;
                                  yyval.rval.val.string_ind = string_table_add(yyvsp[0].name_index); }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1681 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 337 "parser.y"


int ISASM_wrap(void)
{
    return 1;
}

void ISASM_error(char * text)
{
    printf("Line %d:  %s near token: %s\n",ISASM_lineno,text,ISASM_text);
}

void quit(char * format, ... )
{
    va_list args;
    char buffer[4096];

    va_start(args,format);
    vsprintf(buffer,format,args);
    ISASM_error(buffer);
    exit(1);
}

