
#ifndef ISIS_GAME_H_INCLUDED
#define ISIS_GAME_H_INCLUDED

#ifdef __cplusplus

#include <isis/game/IsisGameProvider.h>

#include <isis/game/GameApp.h>

#include <isis/game/GraphicsEngine.h>
#include <isis/game/VRAMObject.h>

#include <isis/game/Image2D.h>
#include <isis/game/Texture.h>
#include <isis/game/Font2D.h>

#include <isis/game/VectorAnimation.h>
#include <isis/game/VectorImage.h>

#include <isis/game/SoundEngine.h>

#include <isis/game/GUIGame.h>
#include <isis/game/GUIWindow.h>
#include <isis/game/IMouseHandler.h>
#include <isis/game/IKeyHandler.h>
#include <isis/game/ICustomDraw.h>
#include <isis/game/IFrameUpdate.h>

#endif // #ifdef __cplusplus

#endif // ISIS_GAME_H_INCLUDED

