
#ifndef ISIS_GAME_IVMDESTROYCALLBACK_H_INCLUDED
#define ISIS_GAME_IVMDESTROYCALLBACK_H_INCLUDED 1

#include <string>

#include <isis/ivm.h>

#include <isis/game/IDestroyCallback.h>

namespace Isis {

class IVMDestroyCallback : public IDestroyCallback
{
public:

	IVMDestroyCallback(IVM::Script * pScript, const std::string & sFuncname);
	virtual ~IVMDestroyCallback();

	virtual void DestroyCallback();

	IVM::Script * GetScript();
	std::string GetFuncname();

private:

	IVM::Script * m_pScript;
	std::string m_sFuncname;
};

} // namespace Isis

#endif // ISIS_GAME_IVMDESTROYCALLBACK_H_INCLUDED
