
#ifndef ISIS_GAME_IVMFRAMEUPDATE_H_INCLUDED
#define ISIS_GAME_IVMFRAMEUPDATE_H_INCLUDED 1

#include <string>

#include <isis/ivm.h>

#include <isis/game/IFrameUpdate.h>

namespace Isis {

class IVMFrameUpdate : public IFrameUpdate
{
public:

	IVMFrameUpdate(IVM::Script * pScript, const std::string & sFuncname);
	virtual ~IVMFrameUpdate();

	virtual void FrameUpdate();

	IVM::Script * GetScript();
	std::string GetFuncname();

private:

	IVM::Script * m_pScript;
	std::string m_sFuncname;
};

} // namespace Isis

#endif // ISIS_GAME_IVMFRAMEUPDATE_H_INCLUDED
