
#ifndef ISIS_GAME_IVMMOUSEHANDLER_H_INCLUDED
#define ISIS_GAME_IVMMOUSEHANDLER_H_INCLUDED 1

#include <string>

#include <isis/ivm.h>

#include <isis/game/IMouseHandler.h>

namespace Isis {

class IVMMouseHandler : public IMouseHandler
{
public:

	IVMMouseHandler(IVM::Script * pScript, const std::string & sFuncname);
	virtual ~IVMMouseHandler();

	virtual void HandleMouse(int x, int y, GameApp::ClickType type);

	IVM::Script * GetScript();
	std::string GetFuncname();

private:

	IVM::Script * m_pScript;
	std::string m_sFuncname;
};

} // namespace Isis

#endif // ISIS_GAME_IVMMOUSEHANDLER_H_INCLUDED
