
#ifndef ISIS_IVM_IVMEXCEPTION_H_INCLUDED
#define ISIS_IVM_IVMEXCEPTION_H_INCLUDED 1

#include <string>

#include <isis/util/IsisException.h>

namespace IVM {

class IVMException : public Isis::IsisException
{
public:

    IVMException() : IsisException() {}
    IVMException(const std::string & sMessage) : IsisException(sMessage) {}
	IVMException(const std::string & sMessage, const std::string & sExtra)
		: IsisException(sMessage,sExtra) {}

    virtual ~IVMException() throw () {}
};

}

#endif // ISIS_IVM_IVMEXCEPTION_H_INCLUDED

