
#ifndef ISASM_H_INCLUDED
#define ISASM_H_INCLUDED 1

#include <limits.h>
#ifndef PATH_MAX
# ifdef MAX_PATH
#  define PATH_MAX MAX_PATH
# else
#  define PATH_MAX 4096
# endif
#endif

#include <zlib.h>

#include "isasm_types.h"
#include "isasm_externs.h"
#include "isasm_assembler.h"
#include "isasm_instructions.h"

void isasm_reset_global_state(void);
int save_isz_file(gzFile outfile);

#endif // ISASM_H_INCLUDED

