
#ifndef ISC_H_INCLUDED
#define ISC_H_INCLUDED 1

#include <limits.h>
#ifndef PATH_MAX
# ifdef MAX_PATH
#  define PATH_MAX MAX_PATH
# else
#  define PATH_MAX 4096
# endif
#endif

#include "isc_types.h"
#include "isc_externs.h"
#include "isc_compiler.h"
#include "isc_optimization.h"

#ifdef __cplusplus

void isc_reset_global_state(void);
int save_ism_file(const std::string & infile_name, 
                  const std::string & outfile_name, FILE * outfile);

#endif

#endif // ISC_H_INCLUDED

