
#include <stdio.h>
#include <stdarg.h>

#include <isis/util/errors.h>

void isis_error(char * format, ... )
{
    va_list args;
    char buffer[4096];

    va_start(args,format);
    vsprintf(buffer,format,args);

    fprintf(stderr,buffer);
}

void isis_errorl(char * format, ... )
{
    va_list args;
    char buffer[4096];

    va_start(args,format);
    vsprintf(buffer,format,args);

    fprintf(stderr,"%s\n",buffer);
}

