
#ifndef IVM_FUNCTION_H_INCLUDED
#define IVM_FUNCTION_H_INCLUDED

#include <string>

namespace IVM {

struct Function
{
    Function();
    Function(int first_instr, int num_params, int locals_size,
             std::string name);

    void DebugPrint();

    int iFirstInstr;
    int iNumParams;
    int iLocalsSize;
    std::string sName;
};

} // namespace IVM

#endif // IVM_FUNCTION_H_INCLUDED

