
#ifndef IVM_INSTRUCTION_H_INCLUDED
#define IVM_INSTRUCTION_H_INCLUDED

#include <vector>

#include <isis/ivm/iseformat.h> 

#include "Operand.h"

namespace IVM {

class ISEReader;

struct Instruction
{
    void Load(ISEReader & reader);
    
    void DebugPrint();

    INSTRUCTION_TYPE Type;
    std::vector<Operand> OpList;
};

} // namespace IVM

#endif // IVM_INSTRUCTION_H_INCLUDED

