/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse ISC_parse
#define yylex   ISC_lex
#define yyerror ISC_error
#define yylval  ISC_lval
#define yychar  ISC_char
#define yydebug ISC_debug
#define yynerrs ISC_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     VAR = 258,
     RETURN = 259,
     NEW = 260,
     THIS = 261,
     IF = 262,
     ELSE = 263,
     WHILE = 264,
     FOR = 265,
     BREAK = 266,
     CONTINUE = 267,
     PLUSPLUS = 268,
     MINUSMINUS = 269,
     NEG = 270,
     SHL = 271,
     SHR = 272,
     LOGICAND = 273,
     LOGICOR = 274,
     PLUSEQUALS = 275,
     MINUSEQUALS = 276,
     TIMESEQUALS = 277,
     DIVEQUALS = 278,
     MODEQUALS = 279,
     CMPE = 280,
     CMPNE = 281,
     CMPGE = 282,
     CMPLE = 283,
     IDENT = 284,
     INTEGER = 285,
     FLOAT = 286,
     STRING = 287,
     LOWER_THAN_ELSE = 288
   };
#endif
#define VAR 258
#define RETURN 259
#define NEW 260
#define THIS 261
#define IF 262
#define ELSE 263
#define WHILE 264
#define FOR 265
#define BREAK 266
#define CONTINUE 267
#define PLUSPLUS 268
#define MINUSMINUS 269
#define NEG 270
#define SHL 271
#define SHR 272
#define LOGICAND 273
#define LOGICOR 274
#define PLUSEQUALS 275
#define MINUSEQUALS 276
#define TIMESEQUALS 277
#define DIVEQUALS 278
#define MODEQUALS 279
#define CMPE 280
#define CMPNE 281
#define CMPGE 282
#define CMPLE 283
#define IDENT 284
#define INTEGER 285
#define FLOAT 286
#define STRING 287
#define LOWER_THAN_ELSE 288




/* Copy the first part of user declarations.  */
#line 2 "parser.y"


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <isis/ivm/isc.h>



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 13 "parser.y"
typedef union YYSTYPE {
    int int_val;
    float float_val;
    int name_index;
    EXPR_STRUCT expr;
    LOOP_STRUCT loop;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 169 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 181 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   595

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  41
/* YYNRULES -- Number of rules. */
#define YYNRULES  102
/* YYNRULES -- Number of states. */
#define YYNSTATES  179

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    45,     2,     2,    44,    43,    36,     2,
      50,    51,    41,    39,    52,    40,    47,    42,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    49,
      37,    33,    38,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    55,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    53,    34,    54,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    48
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    18,    24,
      26,    27,    29,    31,    35,    37,    41,    42,    45,    47,
      49,    51,    53,    55,    58,    62,    65,    68,    71,    75,
      78,    83,    85,    88,    97,    99,   101,   103,   105,   107,
     110,   113,   116,   121,   125,   127,   129,   131,   133,   135,
     137,   139,   141,   143,   145,   147,   149,   152,   158,   162,
     168,   175,   179,   183,   187,   191,   195,   198,   201,   204,
     207,   212,   219,   223,   228,   229,   231,   233,   237,   241,
     245,   249,   253,   257,   260,   264,   268,   272,   276,   280,
     283,   287,   291,   295,   299,   303,   307,   311,   315,   319,
     321,   323,   325
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      57,     0,    -1,    58,    -1,    59,    -1,    58,    59,    -1,
      60,    -1,    61,    -1,     3,    29,    49,    -1,    62,    50,
      63,    51,    66,    -1,    29,    -1,    -1,    64,    -1,    65,
      -1,    64,    52,    65,    -1,    29,    -1,    53,    67,    54,
      -1,    -1,    67,    68,    -1,    66,    -1,    69,    -1,    70,
      -1,    73,    -1,    78,    -1,     4,    49,    -1,     4,    83,
      49,    -1,    11,    49,    -1,    12,    49,    -1,    83,    49,
      -1,     3,    29,    49,    -1,    71,    66,    -1,    72,    50,
      83,    51,    -1,     9,    -1,    74,    68,    -1,    10,    50,
      75,    49,    76,    49,    77,    51,    -1,    83,    -1,    83,
      -1,    83,    -1,    81,    -1,    79,    -1,    80,    68,    -1,
      81,     8,    -1,    82,    68,    -1,     7,    50,    83,    51,
      -1,    50,    83,    51,    -1,    84,    -1,    85,    -1,    86,
      -1,    87,    -1,    96,    -1,    88,    -1,    89,    -1,    92,
      -1,    93,    -1,    94,    -1,    95,    -1,     6,    -1,     5,
      29,    -1,     5,    29,    50,    90,    51,    -1,    96,    33,
      83,    -1,    83,    47,    29,    33,    83,    -1,    83,    46,
      83,    55,    33,    83,    -1,    96,    20,    83,    -1,    96,
      21,    83,    -1,    96,    22,    83,    -1,    96,    23,    83,
      -1,    96,    24,    83,    -1,    13,    96,    -1,    96,    13,
      -1,    14,    96,    -1,    96,    14,    -1,    29,    50,    90,
      51,    -1,    83,    47,    29,    50,    90,    51,    -1,    83,
      47,    29,    -1,    83,    46,    83,    55,    -1,    -1,    91,
      -1,    83,    -1,    91,    52,    83,    -1,    83,    39,    83,
      -1,    83,    40,    83,    -1,    83,    41,    83,    -1,    83,
      42,    83,    -1,    83,    43,    83,    -1,    40,    83,    -1,
      83,    36,    83,    -1,    83,    34,    83,    -1,    83,    18,
      83,    -1,    83,    19,    83,    -1,    83,    35,    83,    -1,
      45,    83,    -1,    83,    16,    83,    -1,    83,    17,    83,
      -1,    83,    44,    83,    -1,    83,    25,    83,    -1,    83,
      26,    83,    -1,    83,    38,    83,    -1,    83,    27,    83,
      -1,    83,    37,    83,    -1,    83,    28,    83,    -1,    29,
      -1,    30,    -1,    31,    -1,    32,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    73,    73,    76,    77,    80,    81,    84,    87,    90,
      93,    94,    97,    98,   101,   104,   107,   108,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   123,   126,
     131,   137,   140,   144,   150,   153,   158,   161,   162,   165,
     168,   171,   174,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   192,   194,   198,   202,
     210,   217,   219,   221,   223,   225,   229,   230,   233,   234,
     239,   243,   247,   255,   262,   263,   266,   267,   271,   274,
     277,   280,   283,   286,   291,   294,   297,   300,   303,   306,
     309,   312,   317,   322,   325,   328,   331,   334,   337,   342,
     345,   346,   347
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "VAR", "RETURN", "NEW", "THIS", "IF",
  "ELSE", "WHILE", "FOR", "BREAK", "CONTINUE", "PLUSPLUS", "MINUSMINUS",
  "NEG", "SHL", "SHR", "LOGICAND", "LOGICOR", "PLUSEQUALS", "MINUSEQUALS",
  "TIMESEQUALS", "DIVEQUALS", "MODEQUALS", "CMPE", "CMPNE", "CMPGE",
  "CMPLE", "IDENT", "INTEGER", "FLOAT", "STRING", "'='", "'|'", "'^'",
  "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "'$'", "'!'",
  "'['", "'.'", "LOWER_THAN_ELSE", "';'", "'('", "')'", "','", "'{'",
  "'}'", "']'", "$accept", "issfile", "declist", "dec", "globalscalar",
  "function", "funcname", "paramlist", "params", "param", "block",
  "statements", "statement", "localscalar", "whileloop", "whiletop",
  "whilestart", "forloop", "fortop", "for1", "for2", "for3", "ifexp",
  "ifelse", "iffirst", "iftop", "ifstart", "expression", "assignment",
  "incdec", "funccall", "methcall", "lstruct", "vecarr", "exprlist",
  "exprs", "arithmeticop", "logicalop", "stringop", "comparisonop",
  "rvalue", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    61,   124,    94,    38,    60,    62,    43,
      45,    42,    47,    37,    36,    33,    91,    46,   288,    59,
      40,    41,    44,   123,   125,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    56,    57,    58,    58,    59,    59,    60,    61,    62,
      63,    63,    64,    64,    65,    66,    67,    67,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    78,    79,
      80,    81,    82,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    84,    84,
      84,    84,    84,    84,    84,    84,    85,    85,    85,    85,
      86,    87,    88,    89,    90,    90,    91,    91,    92,    92,
      92,    92,    92,    92,    93,    93,    93,    93,    93,    93,
      93,    93,    94,    95,    95,    95,    95,    95,    95,    96,
      96,    96,    96
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     3,     5,     1,
       0,     1,     1,     3,     1,     3,     0,     2,     1,     1,
       1,     1,     1,     2,     3,     2,     2,     2,     3,     2,
       4,     1,     2,     8,     1,     1,     1,     1,     1,     2,
       2,     2,     4,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     5,     3,     5,
       6,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       4,     6,     3,     4,     0,     1,     1,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     9,     0,     2,     3,     5,     6,     0,     0,
       1,     4,    10,     7,    14,     0,    11,    12,     0,     0,
      16,     8,    13,     0,     0,     0,     0,    55,     0,    31,
       0,     0,     0,     0,     0,    99,   100,   101,   102,     0,
       0,     0,    15,    18,    17,    19,    20,     0,     0,    21,
       0,    22,    38,     0,    37,     0,     0,    44,    45,    46,
      47,    49,    50,    51,    52,    53,    54,    48,     0,    23,
       0,    56,     0,     0,    25,    26,    99,    66,    68,    74,
      83,    89,     0,    29,     0,    32,    39,    40,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    67,    69,     0,     0,     0,     0,     0,     0,    28,
      24,    74,     0,     0,    34,    76,     0,    75,    43,     0,
      90,    91,    86,    87,    93,    94,    96,    98,    85,    88,
      84,    97,    95,    78,    79,    80,    81,    82,    92,     0,
      72,    61,    62,    63,    64,    65,    58,     0,    42,     0,
      70,     0,    30,    73,     0,    74,    57,     0,    35,    77,
       0,    59,     0,     0,    60,    71,     0,    36,    33
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     3,     4,     5,     6,     7,     8,    15,    16,    17,
      43,    23,    44,    45,    46,    47,    48,    49,    50,   123,
     167,   176,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,   126,   127,    63,    64,    65,    66,
      67
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -121
static const short int yypact[] =
{
      14,    -4,  -121,    34,    14,  -121,  -121,  -121,   -12,    -8,
    -121,  -121,    32,  -121,  -121,    -5,    33,  -121,    31,    32,
    -121,  -121,  -121,    -1,    57,   138,    58,  -121,    47,  -121,
      48,    50,    56,    26,    26,    62,  -121,  -121,  -121,   150,
     150,   150,  -121,  -121,  -121,  -121,  -121,    31,    63,  -121,
      97,  -121,  -121,    97,   106,    97,   320,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,   152,    66,  -121,
     354,    73,   150,   150,  -121,  -121,  -121,  -121,  -121,   150,
     -14,   -14,   212,  -121,   150,  -121,  -121,  -121,  -121,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,    87,
    -121,  -121,  -121,   150,   150,   150,   150,   150,   150,  -121,
    -121,   150,   248,    81,   388,   388,    80,    83,  -121,   284,
     -20,   -20,   420,   452,   548,   548,    78,    78,   484,   484,
     516,    78,    78,   429,   429,    16,    16,    16,   -14,   180,
     -15,   388,   388,   388,   388,   388,   388,    82,  -121,   150,
    -121,   150,  -121,    99,   150,   150,  -121,    89,   388,   388,
     150,   388,    90,   150,   388,  -121,    95,   388,  -121
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -121,  -121,  -121,   145,  -121,  -121,  -121,  -121,  -121,   134,
     -11,  -121,   -13,  -121,  -121,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,   -25,  -121,  -121,
    -121,  -121,  -121,  -121,  -120,  -121,  -121,  -121,  -121,  -121,
      17
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      70,   157,    24,    25,    26,    27,    28,    21,    29,    30,
      31,    32,    33,    34,    80,    81,    82,     1,   164,   102,
     103,   104,   105,   106,   107,     9,   108,   109,    35,    36,
      37,    38,   108,   109,    10,   165,    83,    85,    12,    39,
      86,    13,    88,     2,    40,   172,    18,   122,   124,    41,
      77,    78,    20,    42,   125,    76,    36,    37,    38,   129,
     107,    14,   108,   109,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    20,    19,    68,    71,   151,   152,
     153,   154,   155,   156,    89,    90,   125,    72,    73,    74,
      24,    25,    26,    27,    28,    75,    29,    30,    31,    32,
      33,    34,    79,    84,    87,   119,   150,   102,   103,   104,
     105,   106,   107,   121,   108,   109,    35,    36,    37,    38,
     159,   160,   170,   166,   168,   161,   169,    39,   173,   171,
     125,   175,    40,    26,    27,   174,   178,    41,   177,    11,
      20,    33,    34,    22,     0,    26,    27,     0,     0,     0,
       0,     0,     0,    33,    34,   111,   112,    35,    36,    37,
      38,     0,   113,   114,   115,   116,   117,     0,    39,    35,
      36,    37,    38,    40,     0,   118,     0,    69,    41,     0,
      39,     0,     0,     0,     0,    40,    89,    90,    91,    92,
      41,     0,     0,     0,     0,    93,    94,    95,    96,     0,
       0,     0,     0,     0,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,   108,   109,    89,    90,
      91,    92,     0,     0,     0,   163,     0,    93,    94,    95,
      96,     0,     0,     0,     0,     0,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,   108,   109,
       0,     0,     0,   128,    89,    90,    91,    92,     0,     0,
       0,     0,     0,    93,    94,    95,    96,     0,     0,     0,
       0,     0,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,   108,   109,     0,     0,     0,   158,
      89,    90,    91,    92,     0,     0,     0,     0,     0,    93,
      94,    95,    96,     0,     0,     0,     0,     0,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
     108,   109,     0,     0,     0,   162,    89,    90,    91,    92,
       0,     0,     0,     0,     0,    93,    94,    95,    96,     0,
       0,     0,     0,     0,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,   108,   109,     0,   110,
      89,    90,    91,    92,     0,     0,     0,     0,     0,    93,
      94,    95,    96,     0,     0,     0,     0,     0,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
     108,   109,     0,   120,    89,    90,    91,    92,     0,     0,
       0,     0,     0,    93,    94,    95,    96,     0,     0,     0,
       0,     0,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,   108,   109,    89,    90,     0,    92,
       0,     0,     0,     0,     0,    93,    94,    95,    96,     0,
       0,     0,     0,     0,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,   108,   109,    89,    90,
     104,   105,   106,   107,     0,   108,   109,    93,    94,    95,
      96,     0,     0,     0,     0,     0,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,   108,   109,
      89,    90,     0,     0,     0,     0,     0,     0,     0,    93,
      94,    95,    96,     0,     0,     0,     0,     0,     0,     0,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
     108,   109,    89,    90,     0,     0,     0,     0,     0,     0,
       0,    93,    94,    95,    96,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,     0,   108,   109,    89,    90,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,     0,   108,   109
};

static const short int yycheck[] =
{
      25,   121,     3,     4,     5,     6,     7,    18,     9,    10,
      11,    12,    13,    14,    39,    40,    41,     3,    33,    39,
      40,    41,    42,    43,    44,    29,    46,    47,    29,    30,
      31,    32,    46,    47,     0,    50,    47,    50,    50,    40,
      53,    49,    55,    29,    45,   165,    51,    72,    73,    50,
      33,    34,    53,    54,    79,    29,    30,    31,    32,    84,
      44,    29,    46,    47,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    53,    52,    29,    29,   113,   114,
     115,   116,   117,   118,    16,    17,   121,    50,    50,    49,
       3,     4,     5,     6,     7,    49,     9,    10,    11,    12,
      13,    14,    50,    50,     8,    49,    29,    39,    40,    41,
      42,    43,    44,    50,    46,    47,    29,    30,    31,    32,
      49,    51,    33,    51,   159,    52,   161,    40,    49,   164,
     165,    51,    45,     5,     6,   170,    51,    50,   173,     4,
      53,    13,    14,    19,    -1,     5,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    13,    14,    13,    14,    29,    30,    31,
      32,    -1,    20,    21,    22,    23,    24,    -1,    40,    29,
      30,    31,    32,    45,    -1,    33,    -1,    49,    50,    -1,
      40,    -1,    -1,    -1,    -1,    45,    16,    17,    18,    19,
      50,    -1,    -1,    -1,    -1,    25,    26,    27,    28,    -1,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    47,    16,    17,
      18,    19,    -1,    -1,    -1,    55,    -1,    25,    26,    27,
      28,    -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    -1,    -1,    51,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    25,    26,    27,    28,    -1,    -1,    -1,
      -1,    -1,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    -1,    -1,    51,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,
      26,    27,    28,    -1,    -1,    -1,    -1,    -1,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    -1,    -1,    51,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    25,    26,    27,    28,    -1,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,
      26,    27,    28,    -1,    -1,    -1,    -1,    -1,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    25,    26,    27,    28,    -1,    -1,    -1,
      -1,    -1,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    47,    16,    17,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    25,    26,    27,    28,    -1,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    47,    16,    17,
      41,    42,    43,    44,    -1,    46,    47,    25,    26,    27,
      28,    -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    46,    47,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      26,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    47,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    26,    27,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    -1,    46,    47,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    47
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    29,    57,    58,    59,    60,    61,    62,    29,
       0,    59,    50,    49,    29,    63,    64,    65,    51,    52,
      53,    66,    65,    67,     3,     4,     5,     6,     7,     9,
      10,    11,    12,    13,    14,    29,    30,    31,    32,    40,
      45,    50,    54,    66,    68,    69,    70,    71,    72,    73,
      74,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    92,    93,    94,    95,    96,    29,    49,
      83,    29,    50,    50,    49,    49,    29,    96,    96,    50,
      83,    83,    83,    66,    50,    68,    68,     8,    68,    16,
      17,    18,    19,    25,    26,    27,    28,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    46,    47,
      49,    13,    14,    20,    21,    22,    23,    24,    33,    49,
      49,    50,    83,    75,    83,    83,    90,    91,    51,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      29,    83,    83,    83,    83,    83,    83,    90,    51,    49,
      51,    52,    51,    55,    33,    50,    51,    76,    83,    83,
      33,    83,    90,    49,    83,    51,    77,    83,    51
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 73 "parser.y"
    { fixup_ism(); optimize_ism(); }
    break;

  case 7:
#line 84 "parser.y"
    { add_global(yyvsp[-1].name_index,0); }
    break;

  case 8:
#line 87 "parser.y"
    { isc_clear_func_symbols(); }
    break;

  case 9:
#line 90 "parser.y"
    { isc_func_num = isc_new_func(yyvsp[0].name_index); }
    break;

  case 14:
#line 101 "parser.y"
    { isc_add_param(yyvsp[0].name_index); }
    break;

  case 23:
#line 116 "parser.y"
    { emit_return(NULL); }
    break;

  case 24:
#line 117 "parser.y"
    { emit_return(&yyvsp[-1].expr); done_expr(&yyvsp[-1].expr); }
    break;

  case 25:
#line 118 "parser.y"
    { insert_jmp(get_break_target()); }
    break;

  case 26:
#line 119 "parser.y"
    { insert_jmp(get_continue_target()); }
    break;

  case 27:
#line 120 "parser.y"
    { done_expr(&yyvsp[-1].expr); }
    break;

  case 28:
#line 123 "parser.y"
    { isc_add_local(yyvsp[-1].name_index,0); }
    break;

  case 29:
#line 126 "parser.y"
    { insert_jmp(yyvsp[-1].loop.begin_label);
                             insert_label(yyvsp[-1].loop.end_label); 
                             pop_loop(); }
    break;

  case 30:
#line 131 "parser.y"
    { yyval.loop.end_label = make_label();
                                          insert_jz(&yyvsp[-1].expr,yyval.loop.end_label);
                                          done_expr(&yyvsp[-1].expr); yyval.loop.begin_label = 
                                      yyval.loop.continue_label = yyvsp[-3].int_val; push_loop(&yyval.loop); }
    break;

  case 31:
#line 137 "parser.y"
    { yyval.int_val = make_label(); insert_label(yyval.int_val); }
    break;

  case 32:
#line 140 "parser.y"
    { pop_for(); insert_jmp(yyvsp[-1].loop.begin_label); 
                            insert_label(yyvsp[-1].loop.end_label); pop_loop(); }
    break;

  case 33:
#line 144 "parser.y"
    { yyval.loop.begin_label = yyvsp[-5].int_val;
                                         yyval.loop.continue_label = yyvsp[-3].loop.continue_label; 
                                             yyval.loop.end_label = yyvsp[-3].loop.end_label; 
                                             push_loop(&yyval.loop); }
    break;

  case 34:
#line 150 "parser.y"
    { done_expr(&yyvsp[0].expr); yyval.int_val = make_label(); insert_label(yyval.int_val); }
    break;

  case 35:
#line 153 "parser.y"
    { done_expr(&yyvsp[0].expr); yyval.loop.end_label = make_label(); 
                yyval.loop.continue_label = make_label(); insert_jz(&yyvsp[0].expr,yyval.loop.end_label); 
                   push_for(); insert_label(yyval.loop.continue_label); }
    break;

  case 36:
#line 158 "parser.y"
    { done_expr(&yyvsp[0].expr); end_forstart(); }
    break;

  case 37:
#line 161 "parser.y"
    { insert_label(yyvsp[0].int_val); }
    break;

  case 38:
#line 162 "parser.y"
    { insert_label(yyvsp[0].int_val); }
    break;

  case 39:
#line 165 "parser.y"
    { yyval.int_val = yyvsp[-1].int_val; }
    break;

  case 40:
#line 168 "parser.y"
    { yyval.int_val = make_label(); insert_jmp(yyval.int_val); insert_label(yyvsp[-1].int_val); }
    break;

  case 41:
#line 171 "parser.y"
    { yyval.int_val = yyvsp[-1].int_val; }
    break;

  case 42:
#line 174 "parser.y"
    { yyval.int_val = make_label(); insert_jz(&yyvsp[-1].expr,yyval.int_val); 
                                 done_expr(&yyvsp[-1].expr); }
    break;

  case 43:
#line 178 "parser.y"
    { yyval.expr = yyvsp[-1].expr; }
    break;

  case 55:
#line 190 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
	                                yyval.expr.val.reg_num = emit_this_call(); }
    break;

  case 56:
#line 192 "parser.y"
    { yyval.expr.type = EXPR_REGISTER; 
                                        yyval.expr.val.reg_num = emit_new_call(yyvsp[0].name_index,0); }
    break;

  case 57:
#line 194 "parser.y"
    { yyval.expr.type = EXPR_REGISTER; 
                                       yyval.expr.val.reg_num = emit_new_call(yyvsp[-3].name_index,yyvsp[-1].int_val); }
    break;

  case 58:
#line 198 "parser.y"
    { yyval.expr = yyvsp[-2].expr; emit_assignment(&yyvsp[-2].expr,&yyvsp[0].expr);
                                           done_expr(&yyvsp[0].expr); 
                                           if (EXPR_RVAL_SCALAR == yyvsp[-2].expr.type)
                                               isc_add_assigned(yyvsp[-2].expr.val.name); }
    break;

  case 59:
#line 202 "parser.y"
    { EXPR_STRUCT expr; yyval.expr = yyvsp[0].expr;
                                      expr.type = EXPR_LIT_STRING;
                                      expr.val.string_ind = yyvsp[-2].name_index;
                                      emit_push_expr(&expr);
                                      emit_push_expr(&yyvsp[0].expr);
                                      expr.type = EXPR_REGISTER;
              expr.val.reg_num = emit_callobj(&yyvsp[-4].expr,isc_name_table_add("Set"),2); 
                                      done_expr(&yyvsp[-4].expr); done_expr(&expr); }
    break;

  case 60:
#line 210 "parser.y"
    { EXPR_STRUCT expr;
	                              yyval.expr = yyvsp[0].expr;
                                      emit_push_expr(&yyvsp[-3].expr);
                                      emit_push_expr(&yyvsp[0].expr);
                                      expr.type = EXPR_REGISTER;
              expr.val.reg_num = emit_callobj(&yyvsp[-5].expr,isc_name_table_add("Set"),2); 
                                      done_expr(&yyvsp[-5].expr); done_expr(&yyvsp[-3].expr); }
    break;

  case 61:
#line 217 "parser.y"
    { yyval.expr = yyvsp[-2].expr; 
                            emit_opequals(INSTR_ADD,&yyvsp[-2].expr,&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 62:
#line 219 "parser.y"
    { yyval.expr = yyvsp[-2].expr; 
                            emit_opequals(INSTR_SUB,&yyvsp[-2].expr,&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 63:
#line 221 "parser.y"
    { yyval.expr = yyvsp[-2].expr; 
                            emit_opequals(INSTR_MUL,&yyvsp[-2].expr,&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 64:
#line 223 "parser.y"
    { yyval.expr = yyvsp[-2].expr; 
                            emit_opequals(INSTR_DIV,&yyvsp[-2].expr,&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 65:
#line 225 "parser.y"
    { yyval.expr = yyvsp[-2].expr; 
                            emit_opequals(INSTR_MOD,&yyvsp[-2].expr,&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 66:
#line 229 "parser.y"
    { yyval.expr = yyvsp[0].expr; emit_inc(&yyvsp[0].expr); }
    break;

  case 67:
#line 230 "parser.y"
    { yyval.expr.type = EXPR_REGISTER; 
                             yyval.expr.val.reg_num = emit_reg_expression(&yyvsp[-1].expr); 
                             emit_inc(&yyvsp[-1].expr); done_expr(&yyvsp[-1].expr); }
    break;

  case 68:
#line 233 "parser.y"
    { yyval.expr = yyvsp[0].expr; emit_dec(&yyvsp[0].expr); }
    break;

  case 69:
#line 234 "parser.y"
    { yyval.expr.type = EXPR_REGISTER; 
                             yyval.expr.val.reg_num = emit_reg_expression(&yyvsp[-1].expr); 
                             emit_dec(&yyvsp[-1].expr); done_expr(&yyvsp[-1].expr); }
    break;

  case 70:
#line 239 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                          yyval.expr.val.reg_num = emit_call(yyvsp[-3].name_index,yyvsp[-1].int_val); }
    break;

  case 71:
#line 243 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                    yyval.expr.val.reg_num = emit_callobj(&yyvsp[-5].expr,yyvsp[-3].name_index,yyvsp[-1].int_val); }
    break;

  case 72:
#line 247 "parser.y"
    {  EXPR_STRUCT expr; expr.type = EXPR_LIT_STRING; 
                   expr.val.string_ind = yyvsp[0].name_index;
                   emit_push_expr(&expr);
                   yyval.expr.type = EXPR_REGISTER;
               yyval.expr.val.reg_num = emit_callobj(&yyvsp[-2].expr,isc_name_table_add("Get"),1); 
                  done_expr(&yyvsp[-2].expr); }
    break;

  case 73:
#line 255 "parser.y"
    {  
                   emit_push_expr(&yyvsp[-1].expr);
                   yyval.expr.type = EXPR_REGISTER;
                yyval.expr.val.reg_num = emit_callobj(&yyvsp[-3].expr,isc_name_table_add("Get"),1); 
                  done_expr(&yyvsp[-3].expr); done_expr(&yyvsp[-1].expr); }
    break;

  case 74:
#line 262 "parser.y"
    { yyval.int_val = 0; }
    break;

  case 75:
#line 263 "parser.y"
    { yyval.int_val = yyvsp[0].int_val; }
    break;

  case 76:
#line 266 "parser.y"
    { yyval.int_val = 1; emit_push_expr(&yyvsp[0].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 77:
#line 267 "parser.y"
    { yyval.int_val = yyvsp[-2].int_val + 1; emit_push_expr(&yyvsp[0].expr); 
                                done_expr(&yyvsp[0].expr); }
    break;

  case 78:
#line 271 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_ADD,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 79:
#line 274 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_SUB,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 80:
#line 277 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_MUL,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 81:
#line 280 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                  yyval.expr.val.reg_num = emit_2op(INSTR_DIV,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 82:
#line 283 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                  yyval.expr.val.reg_num = emit_2op(INSTR_MOD,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 83:
#line 286 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                   yyval.expr.val.reg_num = emit_1op(INSTR_NEG,&yyvsp[0].expr);
                                    done_expr(&yyvsp[0].expr); }
    break;

  case 84:
#line 291 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                               yyval.expr.val.reg_num = emit_2op(INSTR_BITAND,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 85:
#line 294 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                yyval.expr.val.reg_num = emit_2op(INSTR_BITOR,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 86:
#line 297 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                             yyval.expr.val.reg_num = emit_2op(INSTR_LOGICAND,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 87:
#line 300 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                              yyval.expr.val.reg_num = emit_2op(INSTR_LOGICOR,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 88:
#line 303 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                  yyval.expr.val.reg_num = emit_2op(INSTR_XOR,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 89:
#line 306 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                    yyval.expr.val.reg_num = emit_1op(INSTR_NOT,&yyvsp[0].expr);
                                    done_expr(&yyvsp[0].expr); }
    break;

  case 90:
#line 309 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                  yyval.expr.val.reg_num = emit_2op(INSTR_SHL,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 91:
#line 312 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                  yyval.expr.val.reg_num = emit_2op(INSTR_SHR,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 92:
#line 317 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                               yyval.expr.val.reg_num = emit_2op(INSTR_CONCAT,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 93:
#line 322 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_CMPE,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 94:
#line 325 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                yyval.expr.val.reg_num = emit_2op(INSTR_CMPNE,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 95:
#line 328 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_CMPG,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 96:
#line 331 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                yyval.expr.val.reg_num = emit_2op(INSTR_CMPGE,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 97:
#line 334 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                 yyval.expr.val.reg_num = emit_2op(INSTR_CMPL,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 98:
#line 337 "parser.y"
    { yyval.expr.type = EXPR_REGISTER;
                                yyval.expr.val.reg_num = emit_2op(INSTR_CMPLE,&yyvsp[-2].expr,&yyvsp[0].expr);
                                    done_expr(&yyvsp[-2].expr); done_expr(&yyvsp[0].expr); }
    break;

  case 99:
#line 342 "parser.y"
    { yyval.expr.type = EXPR_RVAL_SCALAR; yyval.expr.val.name = yyvsp[0].name_index;
                                  if (!is_local_scalar(yyvsp[0].name_index) && !is_param(yyvsp[0].name_index) &&
                              !is_global_scalar(yyvsp[0].name_index)) { isc_add_local(yyvsp[0].name_index,0); } }
    break;

  case 100:
#line 345 "parser.y"
    { yyval.expr.type = EXPR_LIT_INTEGER; yyval.expr.val.integer = yyvsp[0].int_val; }
    break;

  case 101:
#line 346 "parser.y"
    { yyval.expr.type = EXPR_LIT_FLOAT; yyval.expr.val.floating = yyvsp[0].float_val; }
    break;

  case 102:
#line 347 "parser.y"
    { yyval.expr.type = EXPR_LIT_STRING; yyval.expr.val.string_ind = yyvsp[0].name_index; }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1786 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 350 "parser.y"


int ISC_wrap(void)
{
    return 1;
}

void ISC_error(char * text)
{
    printf("Line %d: %s near token: %s\n",ISC_lineno,text,ISC_text);
}

void ISC_quit(char * format, ... )
{
    va_list args;
    char buffer[4096];

    va_start(args,format);
    vsprintf(buffer,format,args);
    ISC_error(buffer);
    exit(1);
}


