
#ifndef ISIS_GAME_ICUSTOMDRAW_H_INCLUDED
#define ISIS_GAME_ICUSTOMDRAW_H_INCLUDED 1

#include <isis/util/RefCountObject.h>

#include <isis/game/GameApp.h>

namespace Isis {

class GraphicsEngine;

class ICustomDraw : public virtual RefCountObject
{
public:

	virtual ~ICustomDraw() {}

	virtual void Draw(int x, int y, int width, int height,
					  GraphicsEngine * pGraphicsEngine) = 0;

};

}

#endif // ISIS_GAME_ICUSTOMDRAW_H_INCLUDED
