
#ifndef ISIS_GAME_IKEYHANDLER_H_INCLUDED
#define ISIS_GAME_IKEYHANDLER_H_INCLUDED 1

#include <isis/util/RefCountObject.h>

#include <isis/game/GameApp.h>

namespace Isis {

class IKeyHandler : public virtual RefCountObject
{
public:

	virtual ~IKeyHandler() {}

	virtual void HandleKey(int key, GameApp::ModifierKeys modifiers,
						   bool pressed) = 0;

};

}

#endif // ISIS_GAME_IKEYHANDLER_H_INCLUDED

