
#ifndef ISIS_GAME_IMOUSEHANDLER_H_INCLUDED
#define ISIS_GAME_IMOUSEHANDLER_H_INCLUDED 1

#include <isis/util/RefCountObject.h>

#include <isis/game/GameApp.h>

namespace Isis {

class IMouseHandler : public virtual  RefCountObject
{
public:

	virtual ~IMouseHandler() {}

	virtual void HandleMouse(int x, int y, GameApp::ClickType type) = 0;

};

}

#endif // ISIS_GAME_IMOUSEHANDLER_H_INCLUDED

