
#ifndef ISIS_GAME_IVMCUSTOMDRAW_H_INCLUDED
#define ISIS_GAME_IVMCUSTOMDRAW_H_INCLUDED 1

#include <string>

#include <isis/ivm.h>

#include <isis/game/ICustomDraw.h>

namespace Isis {

class IVMCustomDraw : public ICustomDraw
{
public:

	IVMCustomDraw(IVM::Script * pScript, const std::string & sFuncname);
	virtual ~IVMCustomDraw();

	virtual void Draw(int x, int y, int width, int height,
					  GraphicsEngine * pGraphicsEngine);

	IVM::Script * GetScript();
	std::string GetFuncname();

private:

	IVM::Script * m_pScript;
	std::string m_sFuncname;
};

} // namespace Isis

#endif // ISIS_GAME_IVMCUSTOMDRAW_H_INCLUDED
