
#ifndef ISEFORMAT_H_INCLUDED
#define ISEFORMAT_H_INCLUDED 1

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

typedef enum
{
    OP_STRING,
    OP_INTEGER,
    OP_FLOAT,
    OP_RETVAL,
    OP_SCALAR,
    OP_ARRAY,
    OP_LABEL,
    OP_FUNCINDEX,
    OP_HOSTFUNC,
    OP_HOSTOBJ
} OPERAND_TYPE;

typedef enum
{
    INSTR_MOV,

    INSTR_ADD,
    INSTR_SUB,
    INSTR_MUL,
    INSTR_DIV,
    INSTR_MOD,
    INSTR_NEG,
    INSTR_INC,
    INSTR_DEC,

    INSTR_LOGICAND,
    INSTR_LOGICOR,
    INSTR_BITAND,
    INSTR_BITOR,
    INSTR_XOR,
    INSTR_NOT,
    INSTR_SHL,
    INSTR_SHR,

    INSTR_CONCAT,
    INSTR_GETCHAR,
    INSTR_SETCHAR,

    INSTR_CMPE,
    INSTR_CMPNE,
    INSTR_CMPG,
    INSTR_CMPGE,
    INSTR_CMPL,
    INSTR_CMPLE,

    INSTR_JMP,
    INSTR_JZ,
    INSTR_JNZ,

    INSTR_PUSH,
    INSTR_POP,

    INSTR_THIS,

    INSTR_CALL,
    INSTR_CALLHOST,
    INSTR_CALLOBJ,
    INSTR_RET

} INSTRUCTION_TYPE;


#ifdef __cplusplus
}
#endif // __cplusplus

#endif // ISEFORMAT_H_INCLUDED

