
#ifndef ISIS_UTIL_ISISEXCEPTION_H_INCLUDED
#define ISIS_UTIL_ISISEXCEPTION_H_INCLUDED

#include <string>
#include <exception>

namespace Isis {

class IsisException : public std::exception
{
public:

    IsisException();
    IsisException(const std::string & sMessage);
	IsisException(const std::string & sMessage, const std::string & sExtra);

    virtual ~IsisException() throw () {}

    std::string GetMessage() { return m_sMessage; }

protected:

    std::string m_sMessage;
};

}

#endif // ISIS_UTIL_ISISEXCEPTION_H_INCLUDED

