
#include <isis/game/Image2D.h>

namespace Isis {

#ifdef _DEBUG
int Image2D::m_iGlobalRefCount = 0;
#endif // _DEBUG

Image2D::Image2D()
{
#ifdef _DEBUG
	m_iGlobalRefCount++;
#endif // _DEBUG
}

Image2D::~Image2D()
{
#ifdef _DEBUG
	m_iGlobalRefCount--;
#endif // _DEBUG
}

#ifdef _DEBUG
int Image2D::GetGlobalRefCount()
{
	return m_iGlobalRefCount;
}
#endif // _DEBUG

} // namespace Isis
