
#ifndef IVM_ISESTRUCT_H_INCLUDED
#define IVM_ISESTRUCT_H_INCLUDED

#include <vector>

#include "Instruction.h"
#include "Function.h"

namespace IVM {

struct ISEStruct 
{
	std::string Filename;
    int iMajorVersion;
    int iMinorVersion;
    int iGlobalDataSize;
    std::vector<Instruction> InstructionTable;
    std::vector<std::string> StringTable;
    std::vector<Function>    FunctionTable;
    std::vector<std::string> HostAPITable;
    std::vector<std::string> HostObjTable;
	std::vector<std::pair<int,int> > DebugTable;
};

} // namespace IVM

#endif // IVM_ISESTRUCT_H_INCLUDED

