
#ifndef IVM_IVMCONSOLE_H_INCLUDED
#define IVM_IVMCONSOLE_H_INCLUDED 1

#include <string>
#include <vector>

#include <isis/ivm/IVMObject.h>

namespace IVM {

class Script;
class Value;

class IVMConsole : public IVMObject
{
public:

    virtual void IVMFillExportTable(std::vector<std::string> & table);
    virtual bool IVMContainsMethod(const std::string & funcname);
    virtual IVM::Value IVMCallMethod(const std::string & funcname, 
                               const std::vector<Value> & parameters);
};

} // namespace IVM

#endif // IVM_IVMCONSOLE_H_INCLUDED 

