
#include <isis/ivm/IVMObject.h>

namespace IVM {

#ifdef _DEBUG
int IVMObject::m_iGlobalRefCount = 0;
#endif // _DEBUG

IVMObject::IVMObject()
{
#ifdef _DEBUG
	m_iGlobalRefCount++;
#endif // _DEBUG
}

IVMObject::~IVMObject()
{
#ifdef _DEBUG
	m_iGlobalRefCount--;
#endif // _DEBUG
}

#ifdef _DEBUG
int IVMObject::GetGlobalRefCount()
{
	return m_iGlobalRefCount;
}
#endif // _DEBUG

} // namespace IVM

